#include <windows.h>
#include <iostream>
#include <cmath>

#include "lir941pci.h"

int main()
{
	//    .
	setlocale(LC_ALL, "russian");

	//  PCI-  .
	UCHAR pciNum = 0;
	
	//   PCI-.
	HANDLE pci = 0;

	//   PCI-.
	Open_Driver_LIR_X(pciNum, pci);

	//   .
	if (reinterpret_cast<int>(pci) == -1)
	{
		std::cout << "   ." << std::endl;
		return 1;
	}

	//   PCI-,   .
	UCHAR channelNum = 1;

	//  .
	UCHAR encoderDataWidth = 9;

	//
	//      
	//   PCI-.
	//
	const UCHAR CH_CONTINUAL_QUESTIONING = 2;
	const USHORT pciFrequency = 33000; // 

	//
	//       PCI-.
	//
	USHORT speed = 500; // 
	USHORT pause = 150; // 

	//
	//     .
	//
	USHORT clockRate = static_cast<USHORT>(std::ceil(pciFrequency * 0.5 / speed - 1));
	USHORT pauseRate = static_cast<USHORT>(std::ceil(pause * pciFrequency / 1000.0));

	//     .
	UCHAR control = CH_CONTINUAL_QUESTIONING;

	bool setupSucceded = true;
	
	//
	//   :
	//  ,
	//  ,
	//    
	//   .
	//
	setupSucceded &= AbsWriteDataWidth(pci, channelNum, encoderDataWidth);
	setupSucceded &= AbsWriteClockRate(pci, channelNum, clockRate);
	setupSucceded &= AbsWritePauseRate(pci, channelNum, pauseRate);
	setupSucceded &= AbsWriteControl(pci, channelNum, control);

	//       .
	if (!setupSucceded)
	{
		std::cout << "    ." << std::endl;
		return 2;
	}

	ULONG data = 0;
	UCHAR status = 0;

	char resume = 'y';
	
	//
	//   .
	//
	while (resume != 'n')
	{
		//   .
		AbsReadKanalData(pci, channelNum, data);

		//   .
		AbsReadKanalStatus(pci, channelNum, status);

		std::cout << ": " << data << " : " << static_cast<int>(status) << std::endl;
		
		std::cout << " ? (y/n): "; std::cin >> resume;
		std::cout << std::endl;
	}

	//   PCI-.
	Close_Driver_LIR(pci);

	return 0;
}